/* Problem URL: https://codeforces.com/gym/103388/problem/N */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int y, n;
    cin >> y >> n;

    vi fds(y);
    cin >> fds;

    while (__builtin_popcount(y) != 1) {
        y++;
        fds.push_back(0);
    }
    
    vvi seg(y * 2);

    function<void(int, int, int)> build = [&](int i, int l, int r) {
        if (l == r) {
            seg[i].push_back(fds[i - y]);
            return;
        }

        int mid = (l + r) / 2;

        build(i * 2, l, mid);
        build(i * 2 + 1, mid + 1, r);

        merge(all(seg[i * 2]), all(seg[i * 2 + 1]), back_inserter(seg[i]));
    };

    build(1, 0, y - 1);

    function<int(int, int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr, int v) -> int {
        if (l > tr || r < tl) {
            return 0;
        }

        if (l >= tl && r <= tr) {
            auto lower = lower_bound(all(seg[i]), v);
            return seg[i].end() - lower;
        }

        int mid = (l + r) / 2;

        return query(i * 2, l, mid, tl, tr, v) + query(i * 2 + 1, mid + 1, r, tl, tr, v);
    };

    while (n--) {
        int a, p ,f;
        cin >> a >> p >> f;

        if (fds[a - 1] >= p) {
            cout << "0\n";
            continue;
        }

        cout << query(1, 0, y - 1, a - 1, a + f - 1, p) << '\n';
    }
}
